package pack2;
import javax.xml.soap.*;
import java.util.*;
import javax.xml.namespace.QName;
public class Header1 {

    public static void main(String[] args) {
           String version = "1.2";
        System.out.println("SOAP version is " + version);

        if (!(version.equals("1.1") || version.equals("1.2"))) {
            System.err.println("Value must be 1.1 or 1.2");
            System.exit(1);
        }

        try {
            MessageFactory messageFactory = null;
            if (version.equals("1.1")) {
                messageFactory = MessageFactory.newInstance();
            } else {
                messageFactory = MessageFactory.newInstance(
                            SOAPConstants.SOAP_1_2_PROTOCOL);
            }
            SOAPMessage message = messageFactory.createMessage();
            SOAPHeader header = message.getSOAPHeader();
            String nameSpace = "ns";
            String nameSpaceURI = "http://www.roseindia.net";
            QName train1 = new QName(nameSpaceURI, "trainDesk", nameSpace);
            SOAPHeaderElement orderHeader = header.addHeaderElement(train1);

            if (version.equals("1.1")) {
                orderHeader.setActor("http://www.roseindia.net/training");
            } else {
                orderHeader.setRole("http://www.roseindia.net/training");
            }

            QName ejb = new QName(nameSpaceURI, "ejbDesk", nameSpace);
            SOAPHeaderElement shippingHeader = header.addHeaderElement(
                        ejb);

            if (version.equals("1.1")) {
                shippingHeader.setActor("http://www.roseindia.net/ejb/");
            } else {
                shippingHeader.setRole("http://www.roseindia.net/ejb/");
            }
            QName xml = new QName(
                        nameSpaceURI,
                        "xmlDesk",
                        nameSpace);
            SOAPHeaderElement confirmationHeader = header.addHeaderElement(
                        xml);

            if (version.equals("1.1")) {
                confirmationHeader.setActor("http://www.roseindia.net/xml/");
            } else {
                confirmationHeader.setRole("http://www.roseindia.net/xml/");
            }

            confirmationHeader.setMustUnderstand(true);
            QName struts = new QName(nameSpaceURI, "strutsDesk", nameSpace);
            SOAPHeaderElement billingHeader = header.addHeaderElement(struts);

            if (version.equals("1.1")) {
                billingHeader.setActor("http://www.roseindia.net/struts/");
            } else {
                billingHeader.setRole("http://www.roseindia.net/struts/");
            }
            if (version.equals("1.2")) {
                billingHeader.setRelay(true);
            }
            SOAPBody body = message.getSOAPBody();
            message.saveChanges();
            System.out.println("\n----- Request Message ----\n");
            message.writeTo(System.out);
            System.out.println();
            Iterator allHeaders = header.examineAllHeaderElements();
            while (allHeaders.hasNext()) {
                SOAPHeaderElement headerElement = (SOAPHeaderElement) allHeaders
                    .next();
                QName headerName = headerElement.getElementQName();
                System.out.println("\nHeader name is " + headerName.toString());

                if (version.equals("1.1")) {
                    System.out.println("Actor is " + headerElement.getActor());
                } else {
                    System.out.println("Role is " + headerElement.getRole());
                }

                System.out.println(
                        "mustUnderstand is "
                        + headerElement.getMustUnderstand());

                if (version.equals("1.2")) {
                    System.out.println("relay is " + headerElement.getRelay());
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}